/**********************************************************************************
 *                                                                                *
 *  Random symmetric matrix and vector creation routines                          *
 *                                                                                *
 *                                                                                *
 *  Gil Shklarski and Sivan Toledo, May 2007                                      *
 *                                                                                *
 **********************************************************************************/


#include <stdlib.h>
#include <math.h>
#include <stdio.h>

/* CREATES A SYMMETRIC MATRIX WHERE EACH ELEMENT IS UNIFORMLY CHOSEN FROM (-1,1) */


void createSymmetricMatrix(int N, double **A, long int seedval) {
  int i,j;
  unsigned long int d1,d2;
  unsigned long long int d;

  
  srand48(seedval);
  *A = (double*)malloc(N*N*sizeof(double));
    
  for (i=0;i<N;i++) 
    for (j=i;j<N;j++) {
      d1 = lrand48();
      d2 = lrand48();
      d = ((unsigned long long int)d1<<31)^d2;
      (*A)[i*N+j] = ((double)d/(double)((unsigned long long)1<<61))-1;

    }

  for (i=0;i<N;i++)
    for (j=0;j<i;j++) 
      (*A)[i*N+j] = (*A)[j*N+i];

  return;
}

void createRandomVector(int N, double **x, long int seedval) {
  int i;
  unsigned long int d1,d2;
  unsigned long long int d;


  srand48(seedval);
  *x = (double*)malloc(N*sizeof(double));

  for (i=0;i<N;i++) {
    d1 = lrand48();
    d2 = lrand48();
    d = ((unsigned long long int)d1<<31)^d2;
    (*x)[i] = ((double)d/(double)((unsigned long long)1<<61))-1;
  }
  
  return;
}
